Imports Microsoft.PointOfService
Imports System.Text

Public Class Form1
    WithEvents myExplore As PosExplorer
    WithEvents myMSR As Msr

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        myExplore = New PosExplorer(Me)

        Dim Device As DeviceInfo = myExplore.GetDevice("Msr", "myMSR")
        Dim eFlag As Integer = 0

        Try
            myMSR = myExplore.CreateInstance(Device)
        Catch ex As Exception
            lblStatus.Text = "No MSR Attached - Reconnect or Replace"
            eFlag = 1
        End Try


        If eFlag = 0 Then
            myMSR.Open()
            myMSR.Claim(1000)
            myMSR.DeviceEnabled = True
            myMSR.DataEventEnabled = True
            myMSR.DecodeData = True
            lblStatus.Text = "Ready"
        End If

        Update()

    End Sub

    Private Sub myExplore_DeviceAddedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles myExplore.DeviceAddedEvent
        If (e.Device.Type = "Msr") Then
            myMSR = myExplore.CreateInstance(e.Device)
            lblStatus.Text = "New Msr attached: " & e.Device.ServiceObjectName
            myMSR.Open()
            myMSR.Claim(1000)
            myMSR.DeviceEnabled = True
            myMSR.DataEventEnabled = True
            myMSR.DecodeData = True
            Update()
        End If
    End Sub

    Private Sub myExplore_DeviceRemovedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles myExplore.DeviceRemovedEvent
        If (e.Device.Type = "Msr") Then
            myMSR.DataEventEnabled = False
            myMSR.DecodeData = False
            myMSR.Release()
            myMSR.Close()
            lblStatus.Text = "Msr Detached"
            Update()
        End If

    End Sub

    Private Sub myMSR_DataEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DataEventArgs) Handles myMSR.DataEvent
        Dim myEncode As New ASCIIEncoding
        Dim msrData As String
        Dim InvCard As Boolean = True 'Test for an invalid card condition

        msrData = myEncode.GetString(myMSR.Track2Data)
        Update()
        myMSR.DataEventEnabled = True

        Dim cnn1 As New ADODB.Connection
        Dim rst1 As New ADODB.Recordset

        cnn1.Open("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=c:\Database\POS_ID.mdb")
        Dim str1 As String = "SELECT EmployeeID, Name, BadgeNumber, Access FROM Employees"
        With rst1
            .ActiveConnection = cnn1
            .Open(str1, , ADODB.CursorTypeEnum.adOpenForwardOnly, ADODB.LockTypeEnum.adLockPessimistic)

        End With

        Do Until rst1.EOF
            Dim strID As String = CStr(rst1("EmployeeID").Value)
            Dim Name As String = rst1("Name").Value
            Dim Badge As String = rst1("BadgeNumber").Value
            Dim Access As Boolean = rst1("Access").Value


            'Display the user name of the card and then display their access
            If Badge = msrData Then
                txtOUT.Text = Name
                If Access.Equals(True) Then
                    lblAccessStatus.ForeColor = Color.Blue
                    lblAccessStatus.Text = "Granted"
                    InvCard = False
                    Exit Do
                Else
                    lblAccessStatus.ForeColor = Color.Red
                    lblAccessStatus.Text = "Denied"
                    InvCard = False
                    Exit Do
                End If
            End If

            rst1.MoveNext()

        Loop

        'If the card is invalid, let the user know
        If InvCard.Equals(True) Then
            txtOUT.Text = "Invalid Card"
            lblAccessStatus.ForeColor = Color.Red
            lblAccessStatus.Text = "Denied"
        End If
        lblStatus.Text = "Ready"
        Update()

        rst1.Close()
        rst1 = Nothing
        cnn1.Close()
        cnn1 = Nothing

    End Sub

    Private Sub myMSR_ErrorEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceErrorEventArgs) Handles myMSR.ErrorEvent
        lblStatus.Text = "Problem reading card, please try again."
        Update()
        myMSR.DataEventEnabled = True
    End Sub
End Class
